/////////////////////////////////////
//  Generated Initialization File  //
/////////////////////////////////////

#include "C8051F330.h"

//----------
union {
   unsigned short US;   // U.UB[0]- ..
   unsigned char UB[1]; // U.UB[1]- ..
   }U;                  // U.US - 2- ushort .
//----------

void PCA_Init()
{
    PCA0MD    &= ~0x40;
    PCA0MD    = 0x00;
}

void SPI_Init()
{
// 4-wire master,CKPOL=1,CKPHA=1,NSS=1,Fsck=5242880 ,
// SPI Enable (SPI Disable -> SPI0CN=0x0C).
    SPI0CFG   = 0x50;
    SPI0CN    = 0x0D;
    SPI0CKR   = 0x09;
}

void Port_IO_Init()
{
    // P0.0  -  Skipped,     Open-Drain, Digital
    // P0.1  -  Skipped,     Open-Drain, Digital
    // P0.2  -  Skipped,     Open-Drain, Analog
    // P0.3  -  Skipped,     Open-Drain, Analog
    // P0.4  -  SCK  (SPI0), Push-Pull,  Digital
    // P0.5  -  MISO (SPI0), Open-Drain, Digital
    // P0.6  -  MOSI (SPI0), Push-Pull,  Digital
    // P0.7  -  NSS  (SPI0), Push-Pull,  Digital

    // P1.0  -  SYSCLK,      Push-Pull,  Digital
    // P1.1  -  Skipped,     Open-Drain, Digital
    // P1.2  -  T0 (Timr0),  Open-Drain, Digital
    // P1.3  -  Unassigned,  Open-Drain, Digital
    // P1.4  -  Unassigned,  Open-Drain, Digital
    // P1.5  -  Unassigned,  Open-Drain, Digital
    // P1.6  -  Unassigned,  Open-Drain, Digital
    // P1.7  -  Unassigned,  Open-Drain, Digital

    P0MDIN    = 0xF3;
    P0MDOUT   = 0xD0;
    P1MDOUT   = 0x01;
    P0SKIP    = 0x0F;
    P1SKIP    = 0x02;
    XBR0      = 0x0A;
    XBR1      = 0x50;
}

void Oscillator_Init()
{
    int i = 0;
    OSCXCN    = 0x67;//0x67-20971520 Hz, 0x77-10485760 Hz
    for (i = 0; i < 30000; i++);  // Wait 1ms for initialization
    while ((OSCXCN & 0x80) == 0);
    CLKSEL    = 0x01;
    OSCICN    = 0x00;
}

// Initialization function for device,
// Call Init_Device() from your main program
void Init_Device(void)
{
    PCA_Init();
    SPI_Init();
    Port_IO_Init();
    Oscillator_Init();
}
//----------------
void outspi16(unsigned short wor) {
   U.US=wor;

   NSSMD0=0;         //CSAD=0.

   SPI0DAT=U.UB[0];  //  .   SPI.
   while (!SPIF);    //    .
   SPIF=0;           //    .

   SPI0DAT=U.UB[1];  //  .   SPI.
   while (!SPIF);    //    
   SPIF=0;           //    .

   NSSMD0=1;         //CSAD=1.

   }
//-----------------

void main (void)
{
   Init_Device();

//2108 4080 4000 8000 8000 C000 E000 2008 -  10 Hz
//2108 40C0 4000 8000 8000 C000 E000 2008 -  15 Hz
//2108 4100 4000 8000 8000 C000 E000 2008 -  20 Hz
//2108 4280 4000 8000 8000 C000 E000 2008 -  50 Hz
//2108 4500 4000 8000 8000 C000 E000 2008 - 100 Hz
//2108 4A00 4000 8000 8000 C000 E000 2008 - 200 Hz
//2108 5900 4000 8000 8000 C000 E000 2008 - 500 Hz
//2108 7200 4000 8000 8000 C000 E000 2008 -  1 kHz
//2108 6400 4001 8000 8000 C000 E000 2008 -  2 kHz
//2108 7A00 4003 8000 8000 C000 E000 2008 -  5 kHz
//2108 5E00 4005 8000 8000 C000 E000 2008 -  7 kHz
//2108 7400 4007 B400 8007 C000 E000 2008 - 10 khz
//2108 6E00 400B 8000 8000 C000 E000 2008 - 15 kHz
//2108 6800 400F A800 800F C000 E000 2008 - 20 khz
//     4400 4027                          - 50 khz
//2108 4800 404E 8800 804E C000 E000 2000 - 100 khz
//2108 6500 425F 8000 8000 C000 E000 2008 - 777.7 kHz

   outspi16(0x2108);
//-------------------------------

//   outspi16(0x4080);// - 10 Hz
//   outspi16(0x4000);

//   outspi16(0x40C0);// - 15 Hz
//   outspi16(0x4000);

//   outspi16(0x4100);// - 20 Hz
//   outspi16(0x4000);

//   outspi16(0x4280);// - 50 Hz
//   outspi16(0x4000);

//   outspi16(0x4500);// - 100 Hz
//   outspi16(0x4000);

//   outspi16(0x4A00);// - 200 Hz
//   outspi16(0x4000);

//   outspi16(0x5900);// - 500 Hz
//   outspi16(0x4000);

   outspi16(0x7200);// - 1 kHz
   outspi16(0x4000);

//   outspi16(0x6400);// - 2 kHz
//   outspi16(0x4001);

//   outspi16(0x4800);// - 4 kHz
//   outspi16(0x4003);

//  outspi16(0x7A00);// - 5 kHz
//   outspi16(0x4003);

//------------------------
//   outspi16(0x7BA9);// - 5.0331648 kHz
//   outspi16(0x4003);
//------------------------

//   outspi16(0x5E00);// - 7 kHz
//   outspi16(0x4005);

//   outspi16(0x44DA);// - 7.777 kHz
//   outspi16(0x4006);

//   outspi16(0x7400);// - 10 kHz
//   outspi16(0x4007);

//   outspi16(0x6E00);// - 15 kHz
//   outspi16(0x400B);

//   outspi16(0x6800);// - 20 kHz
//   outspi16(0x400F);

//------------------------
//   outspi16(0x4400);// - 50 kHz
//   outspi16(0x4027);
//------------------------

//   outspi16(0x4800); // - 100 kHz
//   outspi16(0x404E);

//------------------------
//   outspi16(0x4DD3);// - 503.31648 kHz
//   outspi16(0x4189);
//------------------------

//   outspi16(0x6500); // - 777.7 kHz
//   outspi16(0x425F);

//-------------------------
   outspi16(0xC000);
   outspi16(0xE000);
   outspi16(0x2008);
//--------------------------

   while (1);                          // loop forever
}
